#include <string.h>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <time.h>
#include <stdio.h>
#include <stdint.h>
#include <iomanip>
#include <unordered_set>

#include <algorithm>    // std::next_permutation, std::sort
#include <vector>
#include <iterator>

using namespace std;

#define fieldsize 8       //maximum 8

#ifndef fieldpoly
  #define fieldpoly 0x15f
#endif

#define NUM_THREADS 1

#define uint unsigned int
#define usint unsigned short int

typedef uint8_t MR;    //matrix row

struct DM_VERTEX {
    MR state[fieldsize]={};
    int parent = -1;
    int XORpos = -1;
    int outpos = -1;
};

struct EqualDM_VERTEX {
    size_t operator () ( const DM_VERTEX& v1, const DM_VERTEX& v2 ) const {
        return (memcmp(v1.state, v2.state, fieldsize*sizeof(uint8_t))==0);
    }
};

void compute_multi_rep(int [][fieldsize]);
void print_Seq(vector < vector<int> > );
vector< vector<int> > Rand_GJ_algo(DM_VERTEX, int, vector<DM_VERTEX> &);

void MITM_precompute(int MAX_STEP, int print_details);
void MITM_search_shell(DM_VERTEX , DM_VERTEX ,  vector<DM_VERTEX> &, int , int );

void sort_V_SortNetwork(DM_VERTEX& V);

/*
** For a given root node (V_r) and a given level (i), this function
** returns the sorted vector of all the nodes reachable after i
** instructions from the root node V_r
**
** Prerequisite: calling the precomputation function MIMT_precompute()
*/
vector<DM_VERTEX> getListFromRoot(DM_VERTEX root, int level);

DM_VERTEX XOR_rows(DM_VERTEX, int, int);
int GJ_algo_DM(DM_VERTEX, vector <DM_VERTEX> &, int , bool );
DM_VERTEX DM_transpose(DM_VERTEX);

static int weightVertex(DM_VERTEX V) {
    int cnt=0;
    for (int i=0; i<fieldsize; i++) {
        for (int j=0; j<fieldsize;j++) {
            if ((V.state[i]>>(fieldsize-1-j))&1) cnt++;
        }
    }
    return cnt;
}

static void printVertex(DM_VERTEX V, int print_mat) {
    if (print_mat>0) {
        for (int i=0; i<fieldsize; i++) {
            for (int j=0; j<fieldsize;j++) {
                if ((V.state[i]>>(fieldsize-1-j))&1) {
                    cout << setw(2) << 1;
                }
                else {
                    cout << setw(2) << 0;
                }
            }
            if (print_mat>1) {
                cout << hex << setw(5) << (int)V.state[i] << dec << endl;
            }
            else {
                cout << endl;
            }
        }
    } else {
        for (int i=0; i<fieldsize; i++) {
            cout << hex << setw(3) << (int)V.state[i] << dec;
        }
    }
    cout << endl;
    return;
}

static void printVertex_inst(DM_VERTEX V) {
    cout << "Row " << V.XORpos << " ^= Row " << V.outpos << endl;
    return;
}

static void print_to_file(DM_VERTEX V, int print_mat, ofstream& fout) {
    if (print_mat>0) {
        for (int i=0; i<fieldsize; i++) {
            for (int j=0; j<fieldsize;j++) {
                if ((V.state[i]>>(fieldsize-1-j))&1) {
                    fout << setw(2) << 1;
                }
                else {
                    fout << setw(2) << 0;
                }
            }
            if (print_mat>1) {
                fout << hex << setw(5) << (int)V.state[i] << dec << "\n";
            }
            else {
                fout << "\n";
            }
        }
    }
    else {
        for (int i=0; i<fieldsize; i++) {
            fout << hex << setw(2) << (int)V.state[i] << dec << "\n";
        }
    }
    fout << "\n";
    return;
}
